﻿using Infragistics.Web.UI.GridControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    public List<CheckedRows> rows;
    protected void Page_Load(object sender, EventArgs e)
    {
        this.WebHierarchicalDataGrid1.DataSource = GenerateData();
        this.WebHierarchicalDataGrid1.DataBind();

    }

    private DataSet GenerateData()
    {

        DataSet DataSet_Remittance = new DataSet();
        System.Data.DataTable table = new DataTable();
        table.TableName = "Table1";
        System.Data.DataTable table1 = new DataTable();
        table1.TableName = "Table2";


        DataSet_Remittance.Tables.Add(table);
        DataSet_Remittance.Tables.Add(table1);
        DataColumn columnCompanyName;
        columnCompanyName = new DataColumn();
        columnCompanyName.DataType = System.Type.GetType("System.String");
        columnCompanyName.ColumnName = "CompanyName";

        DataSet_Remittance.Tables[0].Columns.Add(columnCompanyName);

        DataColumn columncompany_id;
        columncompany_id = new DataColumn();
        columncompany_id.DataType = System.Type.GetType("System.Int32");
        columncompany_id.ColumnName = "company_id";
        DataSet_Remittance.Tables[0].Columns.Add(columncompany_id);

        DataColumn columnchildcompany_id;
        columnchildcompany_id = new DataColumn();
        columnchildcompany_id.DataType = System.Type.GetType("System.Int32");
        columnchildcompany_id.ColumnName = "company_id";
        DataSet_Remittance.Tables[1].Columns.Add(columnchildcompany_id);

        DataColumn columnchildcontact_id;
        columnchildcontact_id = new DataColumn();
        columnchildcontact_id.DataType = System.Type.GetType("System.Int32");
        columnchildcontact_id.ColumnName = "contact_id";
        DataSet_Remittance.Tables[1].Columns.Add(columnchildcontact_id);

        DataColumn columnconatctName;
        columnconatctName = new DataColumn();
        columnconatctName.DataType = System.Type.GetType("System.String");
        columnconatctName.ColumnName = "ContactName";
        DataSet_Remittance.Tables[1].Columns.Add(columnconatctName);


        DataRow row = DataSet_Remittance.Tables[0].NewRow();
        row["CompanyName"] = "Infragistics";
        row["company_id"] = "1012";
        DataSet_Remittance.Tables[0].Rows.Add(row);

        DataRow row1 = DataSet_Remittance.Tables[0].NewRow();
        row1["CompanyName"] = "ABC";
        row1["company_id"] = "1013";
        DataSet_Remittance.Tables[0].Rows.Add(row1);


        DataRow row2 = DataSet_Remittance.Tables[1].NewRow();
        row2["company_id"] = "1012";
        row2["contact_id"] = "1222";
        row2["ContactName"] = "John";
        DataSet_Remittance.Tables[1].Rows.Add(row2);

        DataRow row3 = DataSet_Remittance.Tables[1].NewRow();
        row3["company_id"] = "1012";
        row3["contact_id"] = "1223";
        row3["ContactName"] = "Jeff";
        DataSet_Remittance.Tables[1].Rows.Add(row3);

        DataRow row4 = DataSet_Remittance.Tables[1].NewRow();
        row4["company_id"] = "1013";
        row4["contact_id"] = "1224";
        row4["ContactName"] = "Ben";
        DataSet_Remittance.Tables[1].Rows.Add(row4);

        DataSet_Remittance.Relations.Add(new DataRelation("relEBills",
            DataSet_Remittance.Tables[0].Columns["company_id"],
            DataSet_Remittance.Tables[1].Columns["company_id"]));

        return DataSet_Remittance;
    }
 
    protected void Button1_Click(object sender, EventArgs e)
    {
        rows = new List<CheckedRows>();
        int rowsCnt = this.WebHierarchicalDataGrid1.GridView.Rows.Count;
        for (int i = 0; i < rowsCnt; i++)
        {
           var row = this.WebHierarchicalDataGrid1.GridView.Rows[i];
           if (row.Items[0].Value.ToString() == "True")
                rows.Add(new CheckedRows() { Id = row.Items[1].ToString(), Level = row.Level });

            // get all children of the parent
            this.WebHierarchicalDataGrid1.DataBind();

            var childRows = (row as ContainerGridRecord).RowIslands[0].Rows;
           foreach (var child in childRows)
           {
              // check all children of parent
               if ((child as GridRecord).Items[0].Value.ToString() == "True")
                 rows.Add(new CheckedRows() { Id = (child as ContainerGridRecord).Items[1].ToString(), Level = (child as ContainerGridRecord).Level });     
           }

        }
    }
    public class CheckedRows
    {
        public string Id { get; set; }
        public int Level { get; set; }
    }
}